<?php
/* Autor...: William L. Taype Perez */
/* Esquema.: GSS_SucursalDocumento.xml */
/* Generado: 2020-08-18 04:21:26 */

/* Mantenimiento de los registros de la tabla GSS_SucursalDocumento */
abstract class BaseGSS_SucursalDocumentoDP extends GSS_SucursalDocumentoBV
{
    /* Constructor ( Establece los valores desde un objeto GSS_SucursalDocumentoBN ) */
    public function __construct( GSS_SucursalDocumentoBN $o_GSS_SucursalDocumentoBN = null )
    {
        parent::__construct();
        if ( !is_null( $o_GSS_SucursalDocumentoBN ) )
        {
            $this->setByBN( $o_GSS_SucursalDocumentoBN );
        }
    }

    public $b_Debug = false;

    public function getDebug()
    {
        if( SF_DEBUG )
        {
            $this->b_Debug = true;
        }
        return $this->b_Debug;
    }

    public function setDebug( $v )
    {
        $this->b_Debug = $v;
    }

    /* Establece los valores desde un objeto GSS_SucursalDocumentoBN */
    public function setByBN( GSS_SucursalDocumentoBN $o_GSS_SucursalDocumentoBN )
    {
        if ( !is_null( $o_GSS_SucursalDocumentoBN->getIdSucursalDocumento() ) )
        {
            $this->setIdSucursalDocumento( $o_GSS_SucursalDocumentoBN->getIdSucursalDocumento() );
        }
        if ( !is_null( $o_GSS_SucursalDocumentoBN->getIdCompania() ) )
        {
            $this->setIdCompania( $o_GSS_SucursalDocumentoBN->getIdCompania() );
        }
        if ( !is_null( $o_GSS_SucursalDocumentoBN->getIdSucursal() ) )
        {
            $this->setIdSucursal( $o_GSS_SucursalDocumentoBN->getIdSucursal() );
        }
        if ( !is_null( $o_GSS_SucursalDocumentoBN->getIdTipoDocumento() ) )
        {
            $this->setIdTipoDocumento( $o_GSS_SucursalDocumentoBN->getIdTipoDocumento() );
        }
        if ( !is_null( $o_GSS_SucursalDocumentoBN->getDocumentoTicketFlag() ) )
        {
            $this->setDocumentoTicketFlag( $o_GSS_SucursalDocumentoBN->getDocumentoTicketFlag() );
        }
        if ( !is_null( $o_GSS_SucursalDocumentoBN->getAutorizacionSunatTicket() ) )
        {
            $this->setAutorizacionSunatTicket( $o_GSS_SucursalDocumentoBN->getAutorizacionSunatTicket() );
        }
        if ( !is_null( $o_GSS_SucursalDocumentoBN->getSerieTicket() ) )
        {
            $this->setSerieTicket( $o_GSS_SucursalDocumentoBN->getSerieTicket() );
        }
        if ( !is_null( $o_GSS_SucursalDocumentoBN->getDocumentoFormatoFlag() ) )
        {
            $this->setDocumentoFormatoFlag( $o_GSS_SucursalDocumentoBN->getDocumentoFormatoFlag() );
        }
        if ( !is_null( $o_GSS_SucursalDocumentoBN->getEmpresaImprimioFormato() ) )
        {
            $this->setEmpresaImprimioFormato( $o_GSS_SucursalDocumentoBN->getEmpresaImprimioFormato() );
        }
        if ( !is_null( $o_GSS_SucursalDocumentoBN->getRUCImprimioFormato() ) )
        {
            $this->setRUCImprimioFormato( $o_GSS_SucursalDocumentoBN->getRUCImprimioFormato() );
        }
        if ( !is_null( $o_GSS_SucursalDocumentoBN->getAutorizacionImprimioFormato() ) )
        {
            $this->setAutorizacionImprimioFormato( $o_GSS_SucursalDocumentoBN->getAutorizacionImprimioFormato() );
        }
        if ( !is_null( $o_GSS_SucursalDocumentoBN->getFechaInicioFormato() ) )
        {
            $this->setFechaInicioFormato( $o_GSS_SucursalDocumentoBN->getFechaInicioFormato() );
        }
        if ( !is_null( $o_GSS_SucursalDocumentoBN->getFechaFinFormato() ) )
        {
            $this->setFechaFinFormato( $o_GSS_SucursalDocumentoBN->getFechaFinFormato() );
        }
        if ( !is_null( $o_GSS_SucursalDocumentoBN->getSerieFormato() ) )
        {
            $this->setSerieFormato( $o_GSS_SucursalDocumentoBN->getSerieFormato() );
        }
        if ( !is_null( $o_GSS_SucursalDocumentoBN->getNumeroActual() ) )
        {
            $this->setNumeroActual( $o_GSS_SucursalDocumentoBN->getNumeroActual() );
        }
        if ( !is_null( $o_GSS_SucursalDocumentoBN->getRangoDesdeFormato() ) )
        {
            $this->setRangoDesdeFormato( $o_GSS_SucursalDocumentoBN->getRangoDesdeFormato() );
        }
        if ( !is_null( $o_GSS_SucursalDocumentoBN->getRangoHastaFormato() ) )
        {
            $this->setRangoHastaFormato( $o_GSS_SucursalDocumentoBN->getRangoHastaFormato() );
        }
        if ( !is_null( $o_GSS_SucursalDocumentoBN->getEstado() ) )
        {
            $this->setEstado( $o_GSS_SucursalDocumentoBN->getEstado() );
        }
        if ( !is_null( $o_GSS_SucursalDocumentoBN->getFechaCreacion() ) )
        {
            $this->setFechaCreacion( $o_GSS_SucursalDocumentoBN->getFechaCreacion() );
        }
        if ( !is_null( $o_GSS_SucursalDocumentoBN->getUsuarioCreacion() ) )
        {
            $this->setUsuarioCreacion( $o_GSS_SucursalDocumentoBN->getUsuarioCreacion() );
        }
        if ( !is_null( $o_GSS_SucursalDocumentoBN->getFechaModificacion() ) )
        {
            $this->setFechaModificacion( $o_GSS_SucursalDocumentoBN->getFechaModificacion() );
        }
        if ( !is_null( $o_GSS_SucursalDocumentoBN->getUsuarioModificacion() ) )
        {
            $this->setUsuarioModificacion( $o_GSS_SucursalDocumentoBN->getUsuarioModificacion() );
        }
    }

    /* Graba un nuevo registro */
    public function save()
    {
        $this->validateRecord();
        $o_GSS_SucursalDocumentoFN = new GSS_SucursalDocumentoFN();
        $o_GSS_SucursalDocumentoBN = $o_GSS_SucursalDocumentoFN->selectByPk( $this->getIdSucursalDocumento() );
        if ( is_null( $o_GSS_SucursalDocumentoBN ) )
        {
            $s_SQLQuery1 = "INSERT INTO GSS_SucursalDocumento ( ";
            $s_SQLQuery2 = "VALUES ( ";
            $s_Separator = "";
            if ( !is_null( $this->getIdSucursalDocumento() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdSucursalDocumento";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdSucursalDocumento()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdCompania() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdCompania";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdCompania()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdSucursal() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdSucursal";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdSucursal()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdTipoDocumento() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdTipoDocumento";
                $s_SQLQuery2 .= $s_Separator."'".$this->getIdTipoDocumento()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getDocumentoTicketFlag() ) )
            {
                $s_SQLQuery1 .= $s_Separator."DocumentoTicketFlag";
                $s_SQLQuery2 .= $s_Separator."'".$this->getDocumentoTicketFlag()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getAutorizacionSunatTicket() ) )
            {
                $s_SQLQuery1 .= $s_Separator."AutorizacionSunatTicket";
                $s_SQLQuery2 .= $s_Separator."'".$this->getAutorizacionSunatTicket()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getSerieTicket() ) )
            {
                $s_SQLQuery1 .= $s_Separator."SerieTicket";
                $s_SQLQuery2 .= $s_Separator."'".$this->getSerieTicket()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getDocumentoFormatoFlag() ) )
            {
                $s_SQLQuery1 .= $s_Separator."DocumentoFormatoFlag";
                $s_SQLQuery2 .= $s_Separator."'".$this->getDocumentoFormatoFlag()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getEmpresaImprimioFormato() ) )
            {
                $s_SQLQuery1 .= $s_Separator."EmpresaImprimioFormato";
                $s_SQLQuery2 .= $s_Separator."'".$this->getEmpresaImprimioFormato()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getRUCImprimioFormato() ) )
            {
                $s_SQLQuery1 .= $s_Separator."RUCImprimioFormato";
                $s_SQLQuery2 .= $s_Separator."'".$this->getRUCImprimioFormato()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getAutorizacionImprimioFormato() ) )
            {
                $s_SQLQuery1 .= $s_Separator."AutorizacionImprimioFormato";
                $s_SQLQuery2 .= $s_Separator."'".$this->getAutorizacionImprimioFormato()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaInicioFormato() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaInicioFormato";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaInicioFormato()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaFinFormato() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaFinFormato";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaFinFormato()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getSerieFormato() ) )
            {
                $s_SQLQuery1 .= $s_Separator."SerieFormato";
                $s_SQLQuery2 .= $s_Separator."'".$this->getSerieFormato()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getNumeroActual() ) )
            {
                $s_SQLQuery1 .= $s_Separator."NumeroActual";
                $s_SQLQuery2 .= $s_Separator."".$this->getNumeroActual()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getRangoDesdeFormato() ) )
            {
                $s_SQLQuery1 .= $s_Separator."RangoDesdeFormato";
                $s_SQLQuery2 .= $s_Separator."".$this->getRangoDesdeFormato()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getRangoHastaFormato() ) )
            {
                $s_SQLQuery1 .= $s_Separator."RangoHastaFormato";
                $s_SQLQuery2 .= $s_Separator."".$this->getRangoHastaFormato()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getEstado() ) )
            {
                $s_SQLQuery1 .= $s_Separator."Estado";
                $s_SQLQuery2 .= $s_Separator."'".$this->getEstado()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaCreacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaCreacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioCreacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UsuarioCreacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUsuarioCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaModificacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaModificacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaModificacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioModificacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UsuarioModificacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUsuarioModificacion()."'";
                $s_Separator = ", ";
            }
            $s_SQLQuery = $s_SQLQuery1." ) ".$s_SQLQuery2." );";
            $o_Resource = Conexion::getConexion();
            $o_Statement = $o_Resource->createStatement();
            $o_Statement->executeQuery( $s_SQLQuery );
            if( $this->getDebug() ){ pr( $s_SQLQuery ); }
        }
        else
        {
            throw new Exception( "El id ya esta registrado." );
        }
        return true;
    }

    /* Actualiza los datos del registro */
    public function update()
    {
        $this->validateRecord();
        if ( true )
        {
            $s_SQLQuery = "UPDATE GSS_SucursalDocumento SET ";
            $s_Separator = "";
            if ( !is_null( $this->getIdCompania() ) )
            {
                $s_SQLQuery .= $s_Separator."IdCompania = ".$this->getIdCompania()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdSucursal() ) )
            {
                $s_SQLQuery .= $s_Separator."IdSucursal = ".$this->getIdSucursal()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdTipoDocumento() ) )
            {
                $s_SQLQuery .= $s_Separator."IdTipoDocumento = '".$this->getIdTipoDocumento()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getDocumentoTicketFlag() ) )
            {
                $s_SQLQuery .= $s_Separator."DocumentoTicketFlag = '".$this->getDocumentoTicketFlag()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getAutorizacionSunatTicket() ) )
            {
                $s_SQLQuery .= $s_Separator."AutorizacionSunatTicket = '".$this->getAutorizacionSunatTicket()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getSerieTicket() ) )
            {
                $s_SQLQuery .= $s_Separator."SerieTicket = '".$this->getSerieTicket()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getDocumentoFormatoFlag() ) )
            {
                $s_SQLQuery .= $s_Separator."DocumentoFormatoFlag = '".$this->getDocumentoFormatoFlag()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getEmpresaImprimioFormato() ) )
            {
                $s_SQLQuery .= $s_Separator."EmpresaImprimioFormato = '".$this->getEmpresaImprimioFormato()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getRUCImprimioFormato() ) )
            {
                $s_SQLQuery .= $s_Separator."RUCImprimioFormato = '".$this->getRUCImprimioFormato()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getAutorizacionImprimioFormato() ) )
            {
                $s_SQLQuery .= $s_Separator."AutorizacionImprimioFormato = '".$this->getAutorizacionImprimioFormato()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaInicioFormato() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaInicioFormato = '".$this->getFechaInicioFormato()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaFinFormato() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaFinFormato = '".$this->getFechaFinFormato()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getSerieFormato() ) )
            {
                $s_SQLQuery .= $s_Separator."SerieFormato = '".$this->getSerieFormato()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getNumeroActual() ) )
            {
                $s_SQLQuery .= $s_Separator."NumeroActual = ".$this->getNumeroActual()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getRangoDesdeFormato() ) )
            {
                $s_SQLQuery .= $s_Separator."RangoDesdeFormato = ".$this->getRangoDesdeFormato()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getRangoHastaFormato() ) )
            {
                $s_SQLQuery .= $s_Separator."RangoHastaFormato = ".$this->getRangoHastaFormato()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getEstado() ) )
            {
                $s_SQLQuery .= $s_Separator."Estado = '".$this->getEstado()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaCreacion() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaCreacion = '".$this->getFechaCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioCreacion() ) )
            {
                $s_SQLQuery .= $s_Separator."UsuarioCreacion = '".$this->getUsuarioCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaModificacion() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaModificacion = '".$this->getFechaModificacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioModificacion() ) )
            {
                $s_SQLQuery .= $s_Separator."UsuarioModificacion = '".$this->getUsuarioModificacion()."'";
                $s_Separator = ", ";
            }
            $s_SQLQuery .= " WHERE  IdSucursalDocumento = ".$this->getIdSucursalDocumento().";";
            $o_Resource = Conexion::getConexion();
            $o_Statement = $o_Resource->createStatement();
            $o_Statement->executeQuery( $s_SQLQuery );
            if( $this->getDebug() ){ pr( $s_SQLQuery ); }

        }
        else
        {
            throw new Exception( "El id no esta registrado." );
        }
        return true;
    }

    /* Elimina el registro */
    public function delete()
    {
        $s_SQLQuery = "DELETE FROM GSS_SucursalDocumento WHERE  IdSucursalDocumento = ".$this->getIdSucursalDocumento().";";
        $o_Resource = Conexion::getConexion();
        $o_Statement = $o_Resource->createStatement();
        $o_Statement->executeQuery( $s_SQLQuery );
        if( $this->getDebug() ){ pr( $s_SQLQuery ); }
        return true;
    }

}
?>